%define api 8.6
%define major 0
%define libname %mklibname %{name} %{api} %{major}
%define devname %mklibname %{name} -d

Summary:	An embeddable scripting language
Name:		tcl
Version:	8.6.4
Release:	1
License:	BSD
Group:		System/Libraries
Url:		http://tcl.tk
Source0:	http://downloads.sourceforge.net/%{name}/%{name}-core%{version}-src.tar.gz
Source1:	tcl.macros
Patch0:		tcl-8.5a6-soname.patch
Patch2:		tcl-8.6.3-autopath.patch
Patch3:		tcl-8.6.3-fix_includes.patch
Patch4:		tcl-8.6.3-expect-5.43.0.patch
BuildRequires:	pkgconfig(zlib)
Provides:	/usr/bin/tclsh

%description
Tcl is a simple scripting language designed to be embedded into
other applications.  Tcl is designed to be used with Tk, a widget
set, which is provided in the tk package.  This package also includes
tclsh, a simple example of a Tcl application.

If you're installing the tcl package and you want to use Tcl for
development, you should also install the tk and tclx packages.

%files
%{_bindir}/*
%{_datadir}/%{name}%{api}
%{_mandir}/man1/*
%{_mandir}/man3/*
%{_mandir}/mann/*
%{_datadir}/tcl8
%{_libdir}/%{name}%{api}

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	Shared libraries for %{name}
Group:		System/Libraries
Conflicts:	%{_lib}tcl8.6 < 8.6.4
Obsoletes:	%{_lib}tcl8.6 < 8.6.4

%description -n %{libname}
Tcl is a simple scripting language designed to be embedded into
other applications.  Tcl is designed to be used with Tk, a widget
set, which is provided in the tk package.  This package also includes
tclsh, a simple example of a Tcl application.

If you're installing the tcl package and you want to use Tcl for
development, you should also install the tk and tclx packages.

%files -n %{libname}
%{_libdir}/libtcl%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Development files for %{name}
Group:		Development/Other
Requires:	%{name} = %{EVRD}
Requires:	%{libname} = %{EVRD}
Provides:	%{name}-devel = %{EVRD}

%description -n %{devname}
This package contains development files for %{name}.

%files -n %{devname} -f %{devname}.files
%dir %{_includedir}/tcl%{version}
%dir %{_includedir}/tcl%{version}/compat
%dir %{_includedir}/tcl%{version}/generic
%dir %{_includedir}/tcl%{version}/unix
%{_includedir}/tcl%{version}/compat/*.h
%{_includedir}/tcl%{version}/generic/*.h
%{_includedir}/tcl%{version}/unix/*.h
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/tclConfig.sh
%{_libdir}/tclooConfig.sh
%{_libdir}/pkgconfig/tcl.pc
%{_sys_macros_dir}/tcl.macros

#----------------------------------------------------------------------------

%prep
%setup -qn %{name}%{version}
%patch0 -p1 -b .soname
%patch2 -p1 -b .autopath
%patch3 -p1
%patch4 -p1 -b .expect

%build
pushd unix
    autoconf
    %configure2_5x \
	--enable-threads \
	--enable-gcc \
	--enable-64bit \
	--disable-rpath \
	--includedir=%{_includedir}/tcl%{version}
    %make TCL_LIBRARY=%{_datadir}/%{name}%{api}

    cp libtcl%{api}.so libtcl%{api}.so.%{major}
#    make test
popd

%install
%makeinstall -C unix TCL_LIBRARY=%{buildroot}%{_datadir}/%{name}%{api}

# create the arch-dependent dir
mkdir -p %{buildroot}%{_libdir}/%{name}%{api}

# fix libname
mv %{buildroot}%{_libdir}/libtcl%{api}.so %{buildroot}%{_libdir}/libtcl%{api}.so.%{major}
ln -snf libtcl%{api}.so.%{major} %{buildroot}%{_libdir}/libtcl%{api}.so

# install all headers
install -d %{buildroot}%{_includedir}/tcl%{version}/compat
install -d %{buildroot}%{_includedir}/tcl%{version}/generic
install -d %{buildroot}%{_includedir}/tcl%{version}/unix
install -m0644 compat/*.h %{buildroot}%{_includedir}/tcl%{version}/compat/
install -m0644 generic/*.h %{buildroot}%{_includedir}/tcl%{version}/generic/
install -m0644 unix/*.h %{buildroot}%{_includedir}/tcl%{version}/unix/

pushd %{buildroot}%{_bindir}
    ln -fs tclsh* tclsh
popd

pushd %{buildroot}%{_libdir}
cat > lib%{name}.so << EOF
/* GNU ld script
   We want -l%{name} to include the actual system library,
   which is lib%{name}%{api}.so.%{major}  */
INPUT ( -l%{name}%{api} )
EOF
popd

# fix config script
perl -pi -e "s|-L`pwd`/unix\b|-L%{_libdir}|g" %{buildroot}%{_libdir}/tclConfig.sh
perl -pi -e "s|`pwd`/unix/lib|%{_libdir}/lib|g" %{buildroot}%{_libdir}/tclConfig.sh
perl -pi -e "s|`pwd`|%{_includedir}/tcl%{version}|g" %{buildroot}%{_libdir}/tclConfig.sh

# and let it be found (we don't look in /usr/lib any more)
ln -s %{_libdir}/%{name}Config.sh %{buildroot}/%{_libdir}/%{name}%{api}/%{name}Config.sh

# Arrangements for lib64 platforms
echo "# placeholder" >> %{devname}.files
if [[ "%{_lib}" != "lib" ]]; then
    mkdir -p %{buildroot}%{_prefix}/lib
    ln -s %{_libdir}/tclConfig.sh %{buildroot}%{_prefix}/lib/tclConfig.sh
    echo "%{_prefix}/lib/tclConfig.sh" >> %{devname}.files
fi

# (fc) make sure .so files are writable by root
chmod 755 %{buildroot}%{_libdir}/*.so*

# set up the macros
mkdir -p %{buildroot}%{_sys_macros_dir}
install -m 0644 %{SOURCE1} %{buildroot}%{_sys_macros_dir}


%changelog

* Fri Jun 26 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 8.6.4-1
- (85f6b29) New version 8.6.4
- (85f6b29) Drop tdbc parts as tdbc is moved to individual tarball now
- (85f6b29) Drop no longer needed patches (fixed upstream)
- (85f6b29) Properly name library package (follow library packaging policy)
- (85f6b29) Spec cleanup


